"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Panel = _interopRequireDefault(require("../../styles/cspace-layout/Panel.css"));

var _PanelButtonBar = _interopRequireDefault(require("../../styles/cspace-layout/PanelButtonBar.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  buttons: _propTypes.default.arrayOf(_propTypes.default.node),
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  collapsible: _propTypes.default.bool,
  collapsed: _propTypes.default.bool,
  color: _propTypes.default.string,
  header: _propTypes.default.node,
  name: _propTypes.default.string,
  onToggleCollapsed: _propTypes.default.func
};
const defaultProps = {
  buttons: undefined,
  children: undefined,
  className: undefined,
  collapsible: false,
  collapsed: false,
  color: 'black',
  header: undefined,
  name: undefined,
  onToggleCollapsed: undefined
};

class Panel extends _react.Component {
  constructor(props) {
    super(props);
    this.handleHeaderClick = this.handleHeaderClick.bind(this);
  }

  handleHeaderClick() {
    const {
      collapsible,
      collapsed,
      name,
      onToggleCollapsed
    } = this.props;

    if (collapsible && onToggleCollapsed) {
      onToggleCollapsed(name, !collapsed);
    }
  }

  renderHeader() {
    const {
      buttons,
      collapsible,
      header
    } = this.props;

    if (!header) {
      return null;
    }

    const content = collapsible ? /*#__PURE__*/_react.default.createElement("button", {
      type: "button",
      onClick: this.handleHeaderClick
    }, header) : /*#__PURE__*/_react.default.createElement("div", null, header);
    let buttonBar = null;

    if (buttons && buttons.length > 0) {
      buttonBar = /*#__PURE__*/_react.default.createElement("div", {
        className: _PanelButtonBar.default.common
      }, buttons);
    }

    return /*#__PURE__*/_react.default.createElement("header", null, content, buttonBar);
  }

  renderBody() {
    const {
      collapsible,
      collapsed,
      children
    } = this.props;

    if (collapsible && collapsed) {
      return null;
    }

    return /*#__PURE__*/_react.default.createElement("div", null, children);
  }

  render() {
    const header = this.renderHeader();
    const body = this.renderBody();
    const {
      className,
      collapsible,
      collapsed,
      color
    } = this.props;
    const classes = (0, _classnames.default)(className, _Panel.default.common, _Panel.default[color], collapsible && collapsed ? _Panel.default.collapsed : '');
    return /*#__PURE__*/_react.default.createElement("section", {
      className: classes
    }, header, body);
  }

}

exports.default = Panel;
Panel.propTypes = propTypes;
Panel.defaultProps = defaultProps;