"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Popup = _interopRequireDefault(require("../../styles/cspace-layout/Popup.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const propTypes = {
  children: _propTypes.default.node,
  tabIndex: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  onMouseLeave: _propTypes.default.func,

  /**
   * Callback to be executed after the Popup has mounted.
   */
  onMount: _propTypes.default.func
};
const defaultProps = {
  children: undefined,
  tabIndex: '-1',
  onBlur: undefined,
  onKeyDown: undefined,
  onMouseLeave: undefined,
  onMount: undefined
};

class Popup extends _react.Component {
  constructor() {
    super();
    this.handleBlur = this.handleBlur.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.handleRef = this.handleRef.bind(this);
  }

  componentDidMount() {
    const {
      onMount
    } = this.props;

    if (onMount) {
      onMount();
    }
  }

  focus() {
    if (this.domNode) {
      this.domNode.focus();
    }
  }

  handleBlur(event) {
    const {
      onBlur
    } = this.props;

    if (onBlur) {
      onBlur(event);
    }
  }

  handleKeyDown(event) {
    const {
      onKeyDown
    } = this.props;

    if (onKeyDown) {
      onKeyDown(event);
    }
  }

  handleRef(ref) {
    this.domNode = ref;
  }

  render() {
    const {
      children,
      tabIndex,
      onMouseLeave
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _Popup.default.common,
      ref: this.handleRef,
      role: "presentation",
      tabIndex: tabIndex,
      onBlur: this.handleBlur,
      onKeyDown: this.handleKeyDown,
      onMouseLeave: onMouseLeave
    }, children);
  }

}

exports.default = Popup;
Popup.propTypes = propTypes;
Popup.defaultProps = defaultProps;