"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactVirtualized = require("react-virtualized");

require("!style-loader!css-loader!react-virtualized/styles.css");

var _dimensions = _interopRequireDefault(require("../../styles/dimensions.css"));

var _Table = _interopRequireDefault(require("../../styles/cspace-layout/Table.css"));

var _TableRow = _interopRequireDefault(require("../../styles/cspace-layout/TableRow.css"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const propTypes = {
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    label: _propTypes.default.string,
    dataKey: _propTypes.default.string,
    width: _propTypes.default.number
  })),
  showCheckboxColumn: _propTypes.default.bool,
  renderCheckbox: _propTypes.default.func,
  onRowClick: _propTypes.default.func
};
const defaultProps = {
  columns: [],
  showCheckboxColumn: undefined,
  renderCheckbox: undefined,
  onRowClick: undefined
};

const rowClassName = ({
  index
}) => {
  if (index >= 0) {
    return index % 2 === 0 ? _TableRow.default.even : _TableRow.default.odd;
  }

  return null;
};

const cellRenderer = ({
  cellData
}) => cellData;

class Table extends _react.Component {
  constructor(props) {
    super(props);
    this.handleRowClick = this.handleRowClick.bind(this);
  }

  handleRowClick({
    index
  }) {
    const {
      onRowClick
    } = this.props;

    if (onRowClick) {
      onRowClick(index);
    }
  }

  render() {
    const {
      columns,
      renderCheckbox,
      showCheckboxColumn,
      ...remainingProps
    } = this.props;
    const inputHeight = parseInt(_dimensions.default.inputHeight, 10);
    let checkboxColumn;

    if (showCheckboxColumn) {
      checkboxColumn = /*#__PURE__*/_react.default.createElement(_reactVirtualized.Column, {
        key: "check",
        dataKey: "selected",
        disableSort: true,
        cellRenderer: renderCheckbox,
        width: inputHeight - 2,
        flexGrow: 0,
        flexShrink: 0
      });
    }

    return /*#__PURE__*/_react.default.createElement(_reactVirtualized.AutoSizer, null, ({
      height,
      width
    }) => /*#__PURE__*/_react.default.createElement(_reactVirtualized.Table // eslint-disable-next-line react/jsx-props-no-spreading
    , _extends({}, remainingProps, {
      className: _Table.default.common,
      width: width,
      height: height,
      headerHeight: inputHeight,
      rowHeight: inputHeight,
      rowClassName: rowClassName,
      tabIndex: -1,
      onRowClick: this.handleRowClick
    }), checkboxColumn, columns.map(column => /*#__PURE__*/_react.default.createElement(_reactVirtualized.Column, _extends({
      key: column.dataKey,
      cellRenderer: cellRenderer // eslint-disable-next-line react/jsx-props-no-spreading

    }, column)))));
  }

}

exports.default = Table;
Table.SortDirection = _reactVirtualized.SortDirection;
Table.defaultRowRenderer = _reactVirtualized.defaultTableRowRenderer;
Table.propTypes = propTypes;
Table.defaultProps = defaultProps;